Option Compare Binary
Imports System.IO
Imports WortVergleich.CompareDts

Public Class frmWortVergleich
   Private _Liste1 As New FileInfo("..\..\Liste1.txt")
   Private _Liste2 As New FileInfo("..\..\Liste2.txt")

   Private _Saver As New DataSetSaver(Me, "..\..\DataSet.xml")
   Public Sub New()
      InitializeComponent()
      Me.Height = Screen.PrimaryScreen.WorkingArea.Height
      _Saver.Load(CompareDts)
   End Sub
   Private Sub ReadToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ReadToolStripMenuItem.Click
      Dim wrds = CompareDts.Word
      wrds.Clear()
      'Liste1 einlesen, splitten, alle Elemente durchgehen
      For Each wrd In File.ReadAllText(_Liste1.FullName) _
            .Split({Environment.NewLine}, StringSplitOptions.RemoveEmptyEntries)
         Dim rw = wrds.FindByValue(wrd)
         If rw Is Nothing Then
            wrds.AddWordRow(wrd, 1, 0) 'neues wort adden
         Else
            rw.Count1 += 1 'Counter eines bekannten wortes hochzhlen
         End If
      Next
      'das exakt selbe Spiel fr Liste2 - nur wird jetzt die Count2-Property der DataRows verwendet
      For Each wrd In File.ReadAllText(_Liste2.FullName) _
            .Split({Environment.NewLine}, StringSplitOptions.RemoveEmptyEntries)
         Dim rw = wrds.FindByValue(wrd)
         If rw Is Nothing Then
            wrds.AddWordRow(wrd, 0, 1)
         Else
            rw.Count2 += 1
         End If
      Next
   End Sub
   Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) _
         Handles Me.FormClosing
      CompareDts.Word.AcceptChanges()
      _Saver.HandleFormClosing(CompareDts, e)
   End Sub

   Private Sub FilterBindingSource_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs) Handles FilterBindingSource.CurrentChanged
      Dim filter = FilterBindingSource.At(Of FilterRow)()
      'Dim filter = DirectCast(DirectCast(FilterBindingSource.Current, DataRowView).Row, FilterRow)
      Try
         WordBindingSource.Filter = If(filter.IsFilterTextNull, "", filter.FilterText)
      Catch ex As SyntaxErrorException
         WordBindingSource.Filter = Nothing
         MsgBox(ex.Message, MsgBoxStyle.OkOnly, "SyntaxErrorException")
      Catch ex As EvaluateException
         WordBindingSource.Filter = Nothing
         MsgBox(ex.Message, MsgBoxStyle.OkOnly, "EvaluateException")
      End Try
   End Sub

   Private Sub TestToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TestToolStripMenuItem.Click
      Dim toDelete = From rw In CompareDts.Word Where rw.Value.StartsWith("a", StringComparison.OrdinalIgnoreCase)
      For Each rwToDelete In toDelete.ToArray
         rwToDelete.Delete()
      Next
   End Sub
End Class

