Imports CategoryArticle.DBSampleDataSet,System.io, Microsoft.VisualBasic.ControlChars

' Parent-Child-View der Relation Category-Article:
' Im linken Grid kann man eine Kategorie anwhlen, das rechte Grid zeigt daraufhin die dieser Kategorie zugehrigen Artikel an. Beide Tabellen sind vollstndig editierbar.

Public Class frmParentChild

   Public Sub New()
      InitializeComponent()
      Reload()
   End Sub

   Private Sub ReloadToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ReloadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, TestToolStripMenuItem.Click
      Select Case True
         Case sender Is ReloadToolStripMenuItem
            Reload()
         Case sender Is SaveToolStripMenuItem
	  Save()
         Case sender Is TestToolStripMenuItem
            Me.ArticleBindingSource.RemoveAt(2)
      End Select
   End Sub

#Region "allgemein verwendbare Funktionalitt"

   Private _DataFile As New FileInfo("..\..\DBSample.DataSet.xml")

   Private Sub Save()
      Me.Validate()	'bernimmt ggfs. die aktuelle Eingabe, auch wenn noch nicht abgeschlossen. Andernfalls wundert man sich womglich, dass die letzte Eingabe nicht mit abgespeichert wurde
      DBSampleDataSet.WriteXml(_DataFile.FullName)
      DBSampleDataSet.AcceptChanges() 'setzt Dataset.HasChanges auf False. Das hat auswirkungen auf das Schlie-Verhalten in Form_FormClosing 
      Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Reload()
      DBSampleDataSet.Clear()
      For Each tb As DataTable In DBSampleDataSet.Tables
         tb.BeginLoadData() 'deaktiviert whrend des Ladens AktualisierungsVorgnge des Databindings
      Next
      DBSampleDataSet.ReadXml(_Datafile.FullName)
      For Each tb As DataTable In DBSampleDataSet.Tables
         tb.EndLoadData()
      Next
      DBSampleDataSet.EnforceConstraints = True 'tb.BeginLoadData setzt autom. EnforceConstraints.False - also zurcksetzen
      DBSampleDataSet.AcceptChanges()
   End Sub

   Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) _
         Handles Me.FormClosing
      If Not Me.DBSampleDataSet.HasChanges Then Return 'liegen keine nderungen vor, wird auch nix gespeichert
      If e.Cancel Then Return '                 ist Canceln bereits vorgemerkt ist, wird auch nix gespeichert
      Select Case MessageBox.Show(Me, "nderungen speichern?", "Das Ende ist nahe", MessageBoxButtons.YesNoCancel)
         Case DialogResult.No		  'nix tun: schlieen ohne speichern
         Case DialogResult.Yes : Save()		     ' schlieen mit speichern
         Case DialogResult.Cancel : e.Cancel = True	'Schlieung canceln
      End Select
   End Sub

   'Korrektur eines WinForm-Bugs
   Private Sub Form_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
      Me.Validate()	'nochn Bug: DGV kriegt beim Disposen einen ZeilenIndex-Fehler, wenn sich die ZufgeZeile im Edit-Modus befindet
      Me.SuspendLayout()
      With Me.Controls
         'Controls knnten sich theor. auch gegenseitig disposen, ber Events. dieses hier disposed ganz sicher immer das letzte Element was noch da ist
         While .Count > 0 : .Item(.Count - 1).Dispose() : End While
      End With
   End Sub

#End Region 'allgemein verwendbare Funktionalitt

End Class