Imports System.IO
Imports Fahrtenbuch.FahrtenbuchDts

Public Class frmJoiningView

   Private _DefaultFahrer As FahrerRow, _DefaultFahrzeug As FahrzeugRow, _DefaultLinie As LinieRow

   Public Sub New()
      InitializeComponent()
      Location = Screen.PrimaryScreen.WorkingArea.Location
      Reload()
      _DefaultFahrer = DirectCast(DirectCast(FahrerBindingSource.Current, DataRowView).Row, FahrerRow)
      _DefaultFahrzeug = DirectCast(DirectCast(FahrzeugBindingSource.Current, DataRowView).Row, FahrzeugRow)
      _DefaultLinie = DirectCast(DirectCast(LinieBindingSource.Current, DataRowView).Row, LinieRow)
   End Sub

   Private Sub MenuStrip1_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
      Handles SaveToolStripMenuItem.Click, ReloadToolStripMenuItem.Click, AddFahrtToolStripMenuItem.Click
      Select Case True
         Case Sender Is SaveToolStripMenuItem
	  Save()
         Case Sender Is ReloadToolStripMenuItem
	  Reload()
         Case Sender Is AddFahrtToolStripMenuItem
	  FahrtBindingSource.AddNew()
      End Select
   End Sub

   Private Sub btOk_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btOk.Click
      FahrtBindingSource.EndEdit()
      FahrtBindingSource.ResetItem(FahrtBindingSource.Position)
   End Sub

#Region "allgemein verwendbare Funktionalitt"

   Private _DataFile As New FileInfo("..\..\FahrtenbuchDts.DataSet.xml")

   Private Sub Save()
      Me.Validate()	'bernimmt ggfs. die aktuelle Eingabe, auch wenn noch nicht abgeschlossen. Andernfalls wundert man sich womglich, dass die letzte Eingabe nicht mit abgespeichert wurde
      FahrtenbuchDts.WriteXml(_DataFile.FullName)
      FahrtenbuchDts.AcceptChanges() 'setzt Dataset.HasChanges auf False. Das hat auswirkungen auf das Schlie-Verhalten in Form_FormClosing 
      Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Reload()
      FahrtenbuchDts.Clear()
      For Each tb As DataTable In FahrtenbuchDts.Tables
         tb.BeginLoadData() 'deaktiviert whrend des Ladens AktualisierungsVorgnge des Databindings
      Next
      FahrtenbuchDts.ReadXml(_Datafile.FullName)
      For Each tb As DataTable In FahrtenbuchDts.Tables
         tb.EndLoadData()
      Next
      FahrtenbuchDts.EnforceConstraints = True 'tb.BeginLoadData setzt autom. EnforceConstraints.False - also zurcksetzen
      FahrtenbuchDts.AcceptChanges()
   End Sub

   Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) _
         Handles Me.FormClosing
      If Not Me.FahrtenbuchDts.HasChanges Then Return 'liegen keine nderungen vor, wird auch nix gespeichert
      If e.Cancel Then Return '                 ist Canceln bereits vorgemerkt ist, wird auch nix gespeichert
      Select Case MessageBox.Show(Me, "nderungen speichern?", "Das Ende ist nahe", MessageBoxButtons.YesNoCancel)
         Case DialogResult.No		  'nix tun: schlieen ohne speichern
         Case DialogResult.Yes : Save()		     ' schlieen mit speichern
         Case DialogResult.Cancel : e.Cancel = True	'Schlieung canceln
      End Select
   End Sub

   'Korrektur eines WinForm-Bugs
   Private Sub Form_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
      Me.Validate()	'nochn Bug: DGV kriegt beim Disposen einen ZeilenIndex-Fehler, wenn sich die ZufgeZeile im Edit-Modus befindet
      Me.SuspendLayout()
      With Me.Controls
         'Controls knnten sich theor. auch gegenseitig disposen, ber Events. dieses hier disposed ganz sicher immer das letzte Element was noch da ist
         While .Count > 0 : .Item(.Count - 1).Dispose() : End While
      End With
   End Sub

#End Region 'allgemein verwendbare Funktionalitt
End Class