Imports System.IO
Imports PersistData.DataSet1

Public Class frmSimpleView

   Public Sub New()
      InitializeComponent()
      Reload()
   End Sub

   Private Sub MenuStrip1_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles SaveToolStripMenuItem.Click, ReloadToolStripMenuItem.Click, TestToolStripMenuItem.Click
      Select Case True
         Case Sender Is SaveToolStripMenuItem
	  Save()
         Case Sender Is ReloadToolStripMenuItem
	  Reload()
         Case Sender Is TestToolStripMenuItem
	  CalculateTimeSpan()
      End Select
   End Sub

   Private Sub CalculateTimeSpan()
      'ein Beispiel, wie auf typisierte Daten zugreifen und verarbeiten
      Dim tb = DataSet1.DataTable1
      If tb.Rows.Count < 1 Then
         MessageBox.Show("aus einer leeren DataTable kann keine Zeitspanne ermittelt wern")
         Return
      End If
      Dim min = tb.First, max = min
      For Each rw In tb
         If rw.ADateTime < min.ADateTime Then
	  min = rw
         ElseIf rw.ADateTime > max.ADateTime Then
	  max = rw
         End If
      Next
      Dim tspan = max.ADateTime.Subtract(min.ADateTime)
      Dim sTime = String.Format("{0} Tage, {1} Stunden, {2} Minuten, {3} Sekunden", _
         tspan.Days, tspan.Hours, tspan.Minutes, tspan.Seconds)
      MessageBox.Show(String.Join(Environment.NewLine, {"Die maximale Zeitspanne betrgt:", _
         sTime, "und liegt zwischen", min.Text & " und " & max.Text}))
   End Sub
#Region "allgemein verwendbare Funktionalitt"

   Private _Datafile As New FileInfo("..\..\Dataset1.xml")

   Private Sub Save()
      Me.Validate()	'bernimmt ggfs. die aktuelle Eingabe, auch wenn noch nicht abgeschlossen. Andernfalls wundert man sich womglich, dass die letzte Eingabe nicht mit abgespeichert wurde
      DataSet1.WriteXml(_Datafile.FullName)
      DataSet1.AcceptChanges() 'setzt Dataset.HasChanges auf False. Das hat auswirkungen auf das Schlie-Verhalten in Form_FormClosing 
      Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Reload()
      DataSet1.Clear()
      For Each tb As DataTable In DataSet1.Tables
         tb.BeginLoadData() 'deaktiviert whrend des Ladens AktualisierungsVorgnge des Databindings
      Next
      DataSet1.ReadXml(_Datafile.FullName)
      For Each tb As DataTable In DataSet1.Tables
         tb.EndLoadData()
      Next
      DataSet1.EnforceConstraints = True 'tb.BeginLoadData setzt autom. EnforceConstraints.False - also zurcksetzen
      DataSet1.AcceptChanges()
   End Sub

   Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) _
         Handles Me.FormClosing
      If Not Me.DataSet1.HasChanges Then Return 'liegen keine nderungen vor, wird auch nix gespeichert
      If e.Cancel Then Return '                 ist Canceln bereits vorgemerkt ist, wird auch nix gespeichert
      Select Case MessageBox.Show(Me, "nderungen speichern?", "Das Ende ist nahe", MessageBoxButtons.YesNoCancel)
         Case DialogResult.No		  'nix tun: schlieen ohne speichern
         Case DialogResult.Yes : Save()		     ' schlieen mit speichern
         Case DialogResult.Cancel : e.Cancel = True	'Schlieung canceln
      End Select
   End Sub

   'Korrektur eines WinForm-Bugs
   Private Sub Form_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
      Me.Validate()	'nochn Bug: DGV kriegt beim Disposen einen ZeilenIndex-Fehler, wenn sich die ZufgeZeile im Edit-Modus befindet
      Me.SuspendLayout()
      With Me.Controls
         'Controls knnten sich theor. auch gegenseitig disposen, ber Events. dieses hier disposed ganz sicher immer das letzte Element was noch da ist
         While .Count > 0 : .Item(.Count - 1).Dispose() : End While
      End With
   End Sub

#End Region 'allgemein verwendbare Funktionalitt
End Class