Imports System.IO
Imports Phonebook.PhoneDts

Public Class frmPhonebook

   Public Sub New()
      InitializeComponent()
      Location = Screen.PrimaryScreen.WorkingArea.Location
      Reload()
      Dim defaultTitle = DirectCast(DirectCast(TitleBindingSource(0), DataRowView).Row, TitleRow)
      PhoneDts.Person.TitleIDColumn.DefaultValue = defaultTitle.ID
   End Sub

   Private Sub MenuStrip1_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles SaveToolStripMenuItem.Click, ReloadToolStripMenuItem.Click, _
         TestToolStripMenuItem.Click
      Select Case True
         Case Sender Is SaveToolStripMenuItem
	  Save()
         Case Sender Is ReloadToolStripMenuItem
	  Reload()
         Case Sender Is TestToolStripMenuItem
	  CalculateMaxAgeDifference()
      End Select
   End Sub

   Private Sub CalculateMaxAgeDifference()
      'ein Beispiel, wie auf typisierte Daten zugreifen und verarbeiten
      Dim tb = PhoneDts.Person
      If tb.Rows.Count < 1 Then
         MessageBox.Show("aus einer leeren DataTable kann keine Zeitspanne ermittelt wern")
         Return
      End If
      Dim min = tb.FirstOrDefault(Function(rw) Not rw.IsBirthNull)
      If min Is Nothing Then
         MessageBox.Show("die DataTable enthlt keinen Datensatz mit BirthDate angegeben")
         Return
      End If
      Dim max = min
      For Each rw In tb
         If Not rw.IsBirthNull Then
	  If rw.Birth < min.Birth Then
	     min = rw
	  ElseIf rw.Birth > max.Birth Then
	     max = rw
	  End If
         End If
      Next
      Dim tspan = max.Birth.Subtract(min.Birth)
      Dim sTime = String.Format("{0} Tage, {1} Stunden, {2} Minuten, {3} Sekunden", _
         tspan.Days, tspan.Hours, tspan.Minutes, tspan.Seconds)
      MessageBox.Show(String.Join(Environment.NewLine, {"Der maximale Altersunterschied betrgt:", _
         sTime, "und liegt zwischen", min.Name & " und " & max.Name}))
   End Sub

#Region "allgemein verwendbare Funktionalitt"

   Private _Datafile As New FileInfo("..\..\PhoneDts.xml")

   Private Sub Save()
      Me.Validate()	'bernimmt ggfs. die aktuelle Eingabe, auch wenn noch nicht abgeschlossen. Andernfalls wundert man sich womglich, dass die letzte Eingabe nicht mit abgespeichert wurde
      PhoneDts.WriteXml(_Datafile.FullName)
      PhoneDts.AcceptChanges() 'setzt Dataset.HasChanges auf False. Das hat auswirkungen auf das Schlie-Verhalten in Form_FormClosing 
      Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Reload()
      PhoneDts.Clear()
      For Each tb As DataTable In PhoneDts.Tables
         tb.BeginLoadData() 'deaktiviert whrend des Ladens AktualisierungsVorgnge des Databindings
      Next
      PhoneDts.ReadXml(_Datafile.FullName)
      For Each tb As DataTable In PhoneDts.Tables
         tb.EndLoadData()
      Next
      PhoneDts.EnforceConstraints = True 'tb.BeginLoadData setzt autom. EnforceConstraints.False - also zurcksetzen
      PhoneDts.AcceptChanges()
   End Sub

   Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) _
         Handles Me.FormClosing
      If Not Me.PhoneDts.HasChanges Then Return 'liegen keine nderungen vor, wird auch nix gespeichert
      If e.Cancel Then Return '                 ist Canceln bereits vorgemerkt ist, wird auch nix gespeichert
      Select Case MessageBox.Show(Me, "nderungen speichern?", "Das Ende ist nahe", MessageBoxButtons.YesNoCancel)
         Case DialogResult.No		  'nix tun: schlieen ohne speichern
         Case DialogResult.Yes : Save()		     ' schlieen mit speichern
         Case DialogResult.Cancel : e.Cancel = True	'Schlieung canceln
      End Select
   End Sub

   'Korrektur eines WinForm-Bugs
   Private Sub Form_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
      Me.Validate()	'nochn Bug: DGV kriegt beim Disposen einen ZeilenIndex-Fehler, wenn sich die ZufgeZeile im Edit-Modus befindet
      Me.SuspendLayout()
      With Me.Controls
         'Controls knnten sich theor. auch gegenseitig disposen, ber Events. dieses hier disposed ganz sicher immer das letzte Element was noch da ist
         While .Count > 0 : .Item(.Count - 1).Dispose() : End While
      End With
   End Sub

#End Region 'allgemein verwendbare Funktionalitt

End Class