Option Compare Text
Imports System.IO
Imports TextSearch.PhoneDts
Imports Microsoft.VisualBasic.ControlChars

Public Class frmDetailView

   Public Sub New()
      InitializeComponent()
      Location = Screen.PrimaryScreen.WorkingArea.Location
      Reload()
   End Sub

   Private Sub MenuStrip1_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles SaveToolStripMenuItem.Click, ReloadToolStripMenuItem.Click, _
         TestToolStripMenuItem.Click
      Select Case True
         Case Sender Is SaveToolStripMenuItem
	  Save()
         Case Sender Is ReloadToolStripMenuItem
	  Reload()
         Case Sender Is TestToolStripMenuItem
	  Me.PhoneDts.Title.Clear()
	  Me.PhoneDts.Person.Clear()
      End Select
   End Sub

   Private Function FindPerson(pattern As String) As Boolean
      For i = 0 To Me.PersonBindingSource.Count - 1
         Dim person = DirectCast(DirectCast(PersonBindingSource(i), DataRowView).Row, PersonRow)
         If person.Name Like pattern Then
	  PersonBindingSource.Position = i
	  Return True
         End If
      Next
      Return False
   End Function

   Private Sub btSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSearch.Click
      If FindPerson(txtSearch.Text) Then
         Dim person = DirectCast(DirectCast(PersonBindingSource.Current, DataRowView).Row, PersonRow)
         With person
	  MessageBox.Show(String.Format("{1} {2}{0}Geb: {3:d}{0}Tel: {4}", Lf, .FirstName, .Name, .Birth, .Mobil))
         End With
      Else
         MessageBox.Show(String.Concat("Fr '", txtSearch.Text, "' wurde kein Match gefunden"))
      End If
   End Sub

#Region "allgemein verwendbare Funktionalitt"

   Private _Datafile As New FileInfo("..\..\PhoneDts.xml")

   Private Sub Save()
      Me.Validate()	'bernimmt ggfs. die aktuelle Eingabe, auch wenn noch nicht abgeschlossen. Andernfalls wundert man sich womglich, dass die letzte Eingabe nicht mit abgespeichert wurde
      PhoneDts.WriteXml(_Datafile.FullName)
      PhoneDts.AcceptChanges() 'setzt Dataset.HasChanges auf False. Das hat auswirkungen auf das Schlie-Verhalten in Form_FormClosing 
      Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Reload()
      PhoneDts.Clear()
      For Each tb As DataTable In PhoneDts.Tables
         tb.BeginLoadData() 'deaktiviert whrend des Ladens AktualisierungsVorgnge des Databindings
      Next
      PhoneDts.ReadXml(_Datafile.FullName)
      For Each tb As DataTable In PhoneDts.Tables
         tb.EndLoadData()
      Next
      PhoneDts.EnforceConstraints = True 'tb.BeginLoadData setzt autom. EnforceConstraints.False - also zurcksetzen
      PhoneDts.AcceptChanges()
   End Sub

   Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) _
         Handles Me.FormClosing
      If Not Me.PhoneDts.HasChanges Then Return 'liegen keine nderungen vor, wird auch nix gespeichert
      If e.Cancel Then Return '                 ist Canceln bereits vorgemerkt ist, wird auch nix gespeichert
      Select Case MessageBox.Show(Me, "nderungen speichern?", "Das Ende ist nahe", MessageBoxButtons.YesNoCancel)
         Case DialogResult.No		  'nix tun: schlieen ohne speichern
         Case DialogResult.Yes : Save()		     ' schlieen mit speichern
         Case DialogResult.Cancel : e.Cancel = True	'Schlieung canceln
      End Select
   End Sub

   'Korrektur eines WinForm-Bugs
   Private Sub Form_FormClosed(ByVal sender As Object, ByVal e As FormClosedEventArgs) Handles Me.FormClosed
      Me.Validate()	'nochn Bug: DGV kriegt beim Disposen einen ZeilenIndex-Fehler, wenn sich die ZufgeZeile im Edit-Modus befindet
      Me.SuspendLayout()
      With Me.Controls
         'Controls knnten sich theor. auch gegenseitig disposen, ber Events. dieses hier disposed ganz sicher immer das letzte Element was noch da ist
         While .Count > 0 : .Item(.Count - 1).Dispose() : End While
      End With
   End Sub

#End Region 'allgemein verwendbare Funktionalitt

   Private Sub PersonBindingSource_ListChanged(sender As System.Object, e As System.ComponentModel.ListChangedEventArgs) Handles PersonBindingSource.ListChanged

   End Sub
End Class